<h2>Documentation</h2>

<p><em>newbb_to_phpbb</em> is a php script used to migrate the <a href="http://xoopsforge.com/">XOOPS Community Bulletin Board</a> (a.k.a newbb) into a <a href="http://www.phpbb.com/">phpBB</a>.</p>

<h3>1. Configuration</h3>

<p>Before you could use this script, you need to configure some values. This
values are set in the file <strong>config.php</strong>.</p>

<h3>2. Forums and Categories</h3>

<em>
<pre>
    $newbb_to_phpbb->copy_Forums()
</pre>
</em>

<p><strong>ATTENTION:</strong> In order to get a sucessfull migration, id
values should start at 1 in the following tables: `bb_forums', `bb_categories',
`bb_topics', `bb_posts'. To do that those tables are truncated before copy data
into them.</p>

<p><strong>ATTENTION:</strong> Newbb forum categories are not copied. In phpBB there
are not forum categories.</p>

<p>The forum's order is controlled by the fields `left_id' and `right_id'. If
this fields are not properly set errors may happen.</p>

<h3>3. Users and Groups</h3>

<em>
<pre>
    $newbb_to_phpbb->copy_Users()
</pre>
</em>

<p>In our configuration, users are stored in an LDAP server. We use
copy_Users() function to copy users from `xoops.users' table into our LDAP
server. An example entry looks like the following:</p>

<pre>
    # al@example.com, people, example.com
    dn: uid=al@example.com,ou=people,dc=example,dc=com
    objectClass: inetOrgPerson
    cn: Alain Reguera Delgado
    mail: al@example.com
    userPassword:: e01ENX1QUDFEYVJtOE1RZldpNUV1NWtmelFRPT0=
    sn: Reguera Delgado
    uid: al@example.com
    uid: al
    displayName: al
    employeeType: writer
    preferredLanguage: en
</pre>

<p><strong>ATTENTION:</strong>Any distinguished name (DN) in LDAP server,
under the basedn, and equal to that one formed from `xoops.users' during the
migration process, will be removed and replaced for the new one. Verify your
LDAP users DNs before doing the migration.</p>

<p><strong>ATTENTION:</strong>Any user in `phpBB.users' table with `user_id'
greater than 52 will be removed in the user migration process.</p>

<p>When you insert a user into LDAP server it remains there util the user
tries to login into the phpbb system. At that moment if the LDAP
authentication against LDAP `uid' and `userpassword' fields is correct, the
phpBB system inserts a new record for that user into the `phpBB.users' table
if it found that the `username_clean' do exists for the `uid' provided. This
way relationamong user and topics, posts, groups, etc, is established.</p>

<p>Users can have more than one uid in its LDAP entry and can login into phpBB
system using any of them. In that case a different user will be created in the
database for each one used. In the example above user can login using `al' or
`al@example.com' uid.</p>

<p><strong>Note:</strong> I kept this configuration because rfc2377 recommends
using an email format as user id (Ex. `al@example.com'). And I kept a second
more simple uid (Ex. `al') for those users in the forum that don't want to be
logged in as the mail address. Anyway this is something, that could be
discuss, so we could find a better configuration. When doing so, remember that
users entries in LDAP sever may be used for other applications and that the
directory may grow considerably.</p>

<p>When a user is removed from phpBB database it is only removed from phpBB
database no LDAP action is present here to remove the related user entry from
LDAP server.</p>

<h4>3.1. userPassword issue</h4>

<p>Once the `xoops.users' information is copied into LDAP server, users
passwords need to be reseted. This is because when user password is copied into LDAP server
they are recodfied to fit the `userPassword' LDAP format and what is
recodified is not the user password it self but the hash of it.</p>

<p>To solve this issue the <a href="?p=resetpasswd">Reset User's Password</a>
functionallity is provided in this script. You need to run it once users are
successfully copied into LDAP server. Basically, what this functionality does
is generate a random password for each LDAP user and use the mail field to
notify the user of its new password and the need of update it.</p>

<h4>3.2. Manage LDAP user information</h4>

<p>To manage LDAP user information, a web application should be provided, so
the user can update its information. Also, to let administrator manage LDAP users
easily.</p>

<h4>3.3. Groups</h4>

<p>All users will be inserted using the default phpBB group. This is `REGISTERED'.</p>

<p>Once the user migration is complete, the phpBB administrator should reset user permission and define
moderators.</p>

<h3>4. Topics and Posts</h3>

<em>
<pre>
    $newbb_to_phpbb->copy_Topics()
    $newbb_to_phpbb->copy_Posts()
</pre>
</em>

<p>Once topics and posts migration is complete, all topics and posts will be
owned by the `administrator' user (`phpbb.users.user_id = 2').</p>


